﻿-- Author      : Nogarder
-- Create Date : 2013/4/20 11:28:24
local pairs=pairs
local UnitGUID=UnitGUID
local next=next
--
local NPA_EventHandler_FireEvent=NPA.EventHandler.FireEvent

local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID

local NPA_ArrowManager_CreateArrow=NPA.ArrowManager.CreateArrow
local NPA_ArrowManager_ManageArrow=NPA.ArrowManager.ManageArrow
--
local NPA_FrameToGUID_GetFrameByGUID=NPA.FrameToGUID.GetFrameByGUID
--
local ArrowList={}
--
local GetArrow=function(index)
	--don't have to do recycle kind of thing
	--should be one arrow per frame
	--just return if already exists
	if(ArrowList[index])then
		return ArrowList[index]
	end
	--create new one
	ArrowList[index]=NPA_ArrowManager_CreateArrow(index)
	return ArrowList[index]
end
--
local GetIndexByUnitData=function(unitdata)
	if(unitdata.GUID==UnitGUID("player"))then
		return 4
	elseif(unitdata.GUID==UnitGUID("target"))then
		return 5
	elseif(unitdata.GUID==UnitGUID("focus"))then
		return 6
	elseif(unitdata.GUID==UnitGUID("mouseover"))then
		return 7
	else
		return unitdata.Faction
	end
end
--
NPA.EventHandler.RegisterEvent(6,"TargetArrow_SettingUpdated","TargetArrow_Main",function()
	--if setting is empty, unregister event
	if(next(NPA_Setting.TargetArrow))then
		--build filter
		local Filter={
			--0=any, 1=friendly,2=neutral,3=hostile,4=self,5=target,6=focus,7=mouseover
			[0]={},
			[1]={},
			[2]={},
			[3]={},
			[4]={},
			[5]={},
			[6]={},
			[7]={},
		}
		for _,setting in pairs(NPA_Setting.TargetArrow)do
			Filter[setting.From][setting.To]=setting
		end
		--
		NPA.EventHandler.RegisterEvent(7,"Target_Updated","TargetArrow_Main",function(unitdata)
			local startframe=NPA_FrameToGUID_GetFrameByGUID(unitdata.GUID)
			local endframe=NPA_FrameToGUID_GetFrameByGUID(unitdata.TargetGUID)
			if(startframe)then
				local arrow=GetArrow(startframe)
				local targetunitdata=NPA_DataCollector_GetUnitDataByGUID(unitdata.TargetGUID)
				if(startframe:IsShown() and endframe and endframe:IsShown() and targetunitdata)then
					--check condition
					local from=GetIndexByUnitData(unitdata)
					local to=GetIndexByUnitData(targetunitdata)
					--get setting
					local setting=Filter[from][to] or Filter[from][0] or Filter[0][to] or Filter[0][0]
					if(setting)then
						--all frame is visible
						if(arrow:IsShown())then --already shown, just perlong its lifetime
							arrow.LifeTime=1
						else
							--not shown, manage it
							--set startpoint
							arrow:SetPoint("CENTER",startframe,"CENTER",setting.StartOffsetX,setting.StartOffsetY)
							NPA_ArrowManager_ManageArrow(arrow,setting,1)
							--framelevel
							arrow:SetFrameLevel(setting.FrameLevel+arrow:GetParent():GetFrameLevel())
						end
						--set endpoint
						--arrow.EndPoint:SetParent(endframe) --don't set parent
						arrow.EndPoint:SetPoint("CENTER",endframe,"CENTER",setting.EndOffsetX,setting.EndOffsetY)
					else
						arrow:Hide()
					end
				else--hide it 
					arrow:Hide()
				end
			end
		end)
		--hide arrow when hiding module main
		NPA.EventHandler.RegisterEvent(1,"NamePlate_ModuleMain_OnHide","TargetArrow_Main",function(framedata)
			local arrow=GetArrow(framedata.ModuleMain)
			if(arrow)then
				arrow:Hide()
			end
		end)
	else
		NPA.EventHandler.RegisterEvent(7,"Target_Updated","TargetArrow_Main",nil)
	end
	--hide all arrow ,force them to update
	for _,arrow in pairs(ArrowList)do
		arrow:Hide()
	end
end)
--

